package com.szyd.setting;

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.Spinner;

import com.szyd.uhfdemo.MyApp;
import com.szyd.uhfdemo.R;
import com.szyd.util.MLog;
import com.szyd.util.MUtil;

/**
 * author CYD
 * date 2018/11/22
 * 
 */
public class PoweFrequencyFragment extends Fragment implements View.OnClickListener {

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.port_adress_setting, container, false);
    }

    private Spinner powerGet, area_frequency, sesionMode;

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        powerGet = view.findViewById(R.id.powerGet);
        area_frequency = view.findViewById(R.id.area_frequency);
        sesionMode = view.findViewById(R.id.sesionMode);
        ((CheckBox) view.findViewById(R.id.soundSwitch)).setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                MyApp.ifOpenSound = isChecked;
            }
        });

        view.findViewById(R.id.setPower).setOnClickListener(this);
        view.findViewById(R.id.getPower).setOnClickListener(this);
        view.findViewById(R.id.set_area_frequency).setOnClickListener(this);
        view.findViewById(R.id.get_area_frequency).setOnClickListener(this);
        view.findViewById(R.id.set_session_mode).setOnClickListener(this);
        view.findViewById(R.id.get_session_mode).setOnClickListener(this);

        Integer[] powerData = new Integer[26];
        for (int i = 5; i <= 30; i++) {
            powerData[i - 5] = i;
        }
        ArrayAdapter adapter = new ArrayAdapter(getActivity(), R.layout.support_simple_spinner_dropdown_item, powerData);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        powerGet.setAdapter(adapter);

       // initPower();
       // getAreaFrequency();
    }

    //to get the power
    private boolean initPower() {
        int power = MyApp.getMyApp().getIdataLib().powerGet();
        if (power >= 5) {
            powerGet.setSelection(power - 5);
            return true;
        }
        return false;
    }

    //To get the area frequency
    private boolean getAreaFrequency() {
        int area_fq = MyApp.getMyApp().getIdataLib().frequencyModeGet();
        boolean areaFQFlag = area_fq >= 0 && area_fq <= 4;
        if (areaFQFlag)
            area_frequency.setSelection(area_fq);
        return areaFQFlag;
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.setPower: // To set the power
                int value = (int) powerGet.getSelectedItem();
                MLog.e("vauel = " + value);
                boolean ifValue = MyApp.getMyApp().getIdataLib().powerSet(value);
                setResult(ifValue);
                break;
            case R.id.getPower:
                setResult(initPower());
                break;
            case R.id.set_area_frequency:  //To set the area frequency
                int postion = area_frequency.getSelectedItemPosition();
                boolean ifSetAreaFQ = MyApp.getMyApp().getIdataLib().frequencyModeSet(postion);
                setResult(ifSetAreaFQ);
                break;
            case R.id.get_area_frequency:
                setResult(getAreaFrequency());
                break;
            case R.id.set_session_mode:
                int vals = sesionMode.getSelectedItemPosition();
                setResult(MyApp.getMyApp().getIdataLib().sessionModeSet(vals));
                break;
            case R.id.get_session_mode:
                int sMode = MyApp.getMyApp().getIdataLib().sessionModeGet(); //session mode
                boolean modeGetFlag = sMode > -1 && sMode < 4;
                if (modeGetFlag) {
                    sesionMode.setSelection(sMode);
                }
                System.currentTimeMillis();
                setResult(modeGetFlag);
                break;
        }

    }

    private void setResult(boolean flag) {
        if (flag) {
            MUtil.show("Succeeded");
        } else {
            MUtil.show("Failed");
        }
    }

}
